function Norm_p(z) {
    z = Math.abs(z);
    var a1 = 0.0000053830, a2 = 0.0000488906, a3 = 0.0000380036,
        a4 = 0.0032776263, a5 = 0.0211410061, a6 = 0.0498673470;
    var p = (((((a1*z+a2)*z+a3)*z+a4)*z+a5)*z+a6)*z+1;
    p = Math.pow(p, -16);
    return p
}
 
function Norm_z(p) {
    var a0= 2.5066282,  a1=-18.6150006,  a2= 41.3911977,   a3=-25.4410605,
        b1=-8.4735109,  b2= 23.0833674,  b3=-21.0622410,   b4=  3.1308291,
        c0=-2.7871893,  c1= -2.2979648,  c2=  4.8501413,   c3=  2.3212128,
        d1= 3.5438892,  d2=  1.6370678, r, z;
 
    if (p>0.42) {
        r=Math.sqrt(-Math.log(0.5-p));
        z=(((c3*r+c2)*r+c1)*r+c0)/((d2*r+d1)*r+1)
    }
    else {
        r=p*p;
        z=p*(((a3*r+a2)*r+a1)*r+a0)/((((b4*r+b3)*r+b2)*r+b1)*r+1)
    }
    return z
}
 
function getTail() {
    with (document.forms[0]) {
	     if (elements[0].checked) return 'iz'
	else if (elements[1].checked) return 'dcha'
	else if (elements[2].checked) return 'central'
	else if (elements[3].checked) return 'doscolas'
    }
}

function RoundDP(x, dp) {
    var powten = Math.pow(10, dp);
    return (Math.round(x*powten)/powten)
}

function RoundSF(x, sf) {
    if (x==0) return 0;
    with (Math) {
        var magnitude = ceil(log(abs(x))/LN10);	
	var dp = max(0, min(6, sf-magnitude));	
	return RoundDP(x, dp)
    }
}

function checkneg(p, tailType) {
	if (tailType=='iz' & p<.5) return true;
	if (tailType=='dcha' & p>.5) return true;
	return false
}

function ronda(p, fromType, toType, negativo) {
    var newp = tdiz(p, fromType, negativo);
	newp = izrd(newp, toType, negativo);
    return newp
}

function tdiz(p, from, negativo) {

   if (from=='iz') return p;
   if (from=='dcha') return (1-p);	

   if (from=='doscolas')		p = 1 - p/2
   else if (from=='central')	p = p/2 + 0.5
   else if (from=='medio')	p = p + 0.5;

   if (negativo) p = 1-p;
   return p
}

function izrd(p, to, negativo) {

    if (to=='iz')	return p;
    if (to=='dcha')	return (1-p);

    if (negativo) p = 1-p;			

    if (to=='doscolas')	return 2*(1-p);
    if (to=='central')	return (2*p-1);
    if (to=='medio')	return (p-0.5)
}

function paranormal(form) {
    var tipo = getTail(),
	z = form.z.value;
    if (!z | z=="NaN") form.p.value = ""
    else {
	z = eval(z);			
	var p = Norm_p(z);	
	p = ronda(p, 'doscolas', tipo, z<0);
	form.p.value = RoundDP(p, 4)
    }
}

function sobrenormal(form) {
    var p = eval(form.p.value);
    if (p<0 || p>1) form.z.value=""
    else {
	var tipo = getTail();
	var negativo = checkneg(p, tipo);
	p = ronda(p, tipo, 'medio', negativo);
	var z = Norm_z(p);
	if (negativo) z=-z;
	form.z.value=RoundSF(z, 4)
    }
}		

